/*
 *	OpenGL20Logo.h
 *		- image in header, generated from 'OpenGL_Logo_2_0.tga'
 *		- using prediction / RLE / Huff / BASE64 pipe
 */

#ifndef __OPENGL_LOGO_2_0_TGA_INCLUDED
#define __OPENGL_LOGO_2_0_TGA_INCLUDED

class COpenGL_Logo_2_0_tga {
public:
	static inline int n_Width()
	{
		return 150;
	}

	static inline int n_Height()
	{
		return 57;
	}

	static inline const char *p_s_Base64_Data()
	{
		static const char *p_s_data = "AAAAAAEAAAAAAAAAAAAAAAcAAAAKAAAAGAAAABUAAAAcAAAAGgAAAB"
			"4AAAAbAAAAIgAAAAAAAAAAAAAAAAAAAAD8BAUI+AkDBgf39AwLCg36EPv2FP/98ILs8w8OEhMR8vXx+R"
			"oCHBUe5Bjt7xfjHRvrIiYrFhnu3eYoJyAk6efiIyHlMNzoNd7a2NbhKiXV2zZFHykxLP7Z0NHS3z7MO9"
			"Qyu0c3ODlDLTQ8QS7g6shIT0tNs7/TyS9mWTpKP7i5M76XwcLDxImHx0nKUKpTVl3Xr7Kro7XAxcbLzc"
			"+Lj5GFk5VvmV5XVT1AQlFMAYqDgYBEzntxcE5ua2hlYWBSWlhUrbaprqeluqS8mKKgn52nT9mnTO+FOm"
			"d8KfqGzNYZRKoYQfH2lmNbvrBT9wpMv7tXDeMAUWk8gWbVq5HP+uFP1TYqaPRvXsAUQokBMUFGJQ9qNC"
			"SSza08Uf6oU/AbE3O517AUSiQTFggZMoKD5kUDyxq1PXJOPYuf9wp7RwTc7nahRKME1BkDCagYSDTMTY"
			"Gj6nl9VXM1e/c//BT4TYq8vPgolHBQZAyYoYSCUethEo2ZbAQhug3ff5d39jme1sO/lCnzDNV9HUKNHB"
			"YIGE1DDA0pW4tCzaaSSEijgohRKJBe37EO7unQ8mT6m07+MKfeM1/rdAo6N9kDCahhIFGS3uYtOSk1q3"
			"x4ExmyiYMBBo0dHUv8rez/N9n4dh38AU9Y9up0/PKOjf0hhNQwkAW+PZkpW1ytcodqnFpjKFHDpaNHR6"
			"tj7XzfV/Hc/fCnuHpVf2sFHRv6QwmIYAt7nBq3LsrVPd843EZPU1qNHBw19Hq/c+d/N67v3gp5Tn1OX8"
			"BXwWIGBNQwwDfZ2c2KWJTvXMjnPT6bMHR1a/U/+eP/hH94KdwtVO12qOjf0mKNu/hgDubPDoWVu9Q23R"
			"x6elpZqP7X976Gt98Kd0tVPwalfBYgYopX8MBm87NzbK3f2Ft1K1l17mpo6Dv4Qp2SKby+OjXZpPlubD"
			"A32fpce2t30SR55d7Qk+8FOUiqeXzKODSZKWtb1uG2MU785SWqo5wyoKe/yBTlJOn5lGuxkpt29bf64p"
			"5vM7Ow76JoONHr6+AoyHHsXHzbqdPkL3z8uvo3NB1kkv2Alj1iKpgmHonrIU4yS/9ujgZpWTQm82gYR9"
			"Wf53B+Gf+c9ab8WpXwWIBsup8z6XruBnn0dHRO/8BX/t5rR6pg51Vonasuuj1TX16r4mfsOjCm0kqfao"
			"4LGlKZpqGGC3FLHf5W9Fpb30Nv8pIz7HK5XL3Xzgfju/Le9RxBo6+lo39/RhK+ZyjFU1+2WIb1qI+DV7"
			"DpTQqb3JYhvFqKxV9V5oU2i+TegoQWTioVTN0tW4QV/J82gz/7/oX8R5032OV1M9UzSx9Hl4b8f5MvpO"
			"IdK9hsSw4bNKo5Qux27EPWfJOwfoy5XNJKmvyWN/OokyWofH2HPhTfJJvJBNpMlOObCZvh926oMGrZ+6"
			"rref67vjNmp196vnq2/p0pCjqfM3cJ+r2I4ySl8W7buuUZqmpYh6xPaOXeDre25pkqdZm/njyJ97Pktf"
			"c2I3wpvj1HemsXSKhAfD0qTyidchg6ivl8EfxmzQ8/BysNv/j2MqnQ5D/lAdre918tQD+bKmVyjMzX38"
			"5w7VLA2+HV4MTTHeYopc/jfxeUvPc7mOUFNRJU5eChAyUimDa2aTz5xun73P82hn3+zUBxfvulelF377"
			"pXnz8dQcVKtSOMKkOpYvwe37us8C2l7fjstqAwaLjjjNDD1ffDh5kduh1TrSnFU3SHPHx5g6b97Pn4nK"
			"CmoeqeOgzTE+DK9Kf6pdmzgh7er5+px4vt6kxZ8HceCpy/g1JizzPVuGj/4PY6/wYB7V87WPNvwYTpbb"
			"z5FHufHYgt5VCVzQXDJj1b5SljFKihBLTiqYYbxG+4k1q5k51F5QU1D1DkZBcHsJmisn0HWdzAdGHUr1"
			"8/I82Cbt+P871TtfV6A2Cbt+j/pXu6h+TzJrME3Q6v+WTXYwt7a1C6gSYlESnAwbcMi/r6xLiCggvEaG"
			"kXi1y0NkaJtdbbaFNRjgh0x58aqyf5nPRPFGxo9vRw+3pkHlwfO4fX6P1eg357Tqeb0P+fxQaPJDres0"
			"6nU6/p/TvwBFG4Jv/WB8no8r/P7oLmguGRVK2Y3FTt1Yc5wSNJKgXhKiJQXsk1R8Kahc0EAzKCbgJUfj"
			"QiG9V7nSxP4Ln6837HB5b5/Xs2cOb7nT8/uo0oW/17NnDS51/ewXlA8+ZqPo6ILVY5M/ADBtwxuc+T3+"
			"nV5XWI+NdkLTQUoTn26b4U2gy4PPUBFwEKPatBQb9LaldST5PN9/X3mbmruLqG308+koybnY2HVDY+by"
			"sNpkz8D5mo87nQNfUQ3/EC5oNYpVNfX1IesR8/TXZNC8Cg8RFeDxPhT5otRveF1k/3zVZi4kMvFK4et3"
			"Odez14OT/3dWM0t2DfaHBdcOlFQInmUGFRO97fWDdwUIHxLBu4Uqm9yWN/OR8/wWbht5CgGMhtF/G+FN"
			"Q89l671wW8ej9N6UpVOdYoGq+RvRvnE7TCjpaOMvMgcNa8oxytfOCIE3HplTfo1niL2uYaP3ad5pjXNu"
			"G3U3uSxv5zh4diV2ULCiSgRb5oNCmoWnTJnrgt7r/u+u6M26HmaWHYuvC4Bz5xXihIwt+tJRkKMlKlpK"
			"BygSo439OfnKPtdykK1typ1o2XmtEvPy3Dbqb3JYhzx7PYxLdKJVP01FtAMVXBKXwpqJF8x6aZ64Le+X"
			"T2HPnpTfY5d+D0JSIOnpuBGjftST34OHQaJebpKDHZNh/0P1hUH/b4ey51TqeZNBQgaLWXuXajONVzBy"
			"Be72zisjAjqYOcoyNmeHkVHUwzmZb4U1C1XdbqKun5pg0v/Pd8Mrptfy/O69XubNq9CTen4Zybq58Pet"
			"8HTV+z/rWFTR/uW+Hisma1zfZ/E0z/p1bNrUr9u9DGf7WB1NFslGSiV6X0eVYhLRg8WcLB9RXOqnKi78"
			"u9ktf4/SNexeI8SnwpqInXef1KA9ZP5qGO/1/yenSko1+Vfq7XybjwXqHQ+/8j/Q/Bvt/py8/y879yv6"
			"uS94/L+b2i/AY3zzoYbY9m/xdHllDkz3WQXoWt3QqEF/C/f5HnySagyxqb7QhUe7em59vXr3s+32djez"
			"5LwQ3s5z7rnwpvkUmzrdMHozieHp+nDvj+Egt93pZpXzuY9ze+yqhhb9Pm2s39vp9PtdBRC/BUKoeJp3"
			"IIAl5v+70+1AQ75AZul+3ug4gqkF0THpfi0zFhYdYPfj4vB+7nM74nh45GhTfLT2X0OnhVM9GZng/L1O"
			"iQ5ZcXN1c11z53IvQ4NS+R8/3bb1raNTUvhzdnidL+W9zMb53Prr03h2m9J4Op0Yd23l4drJc8lnmVE+"
			"hiwXCLnt4c5RklOxkfXP3q5svy9g6l8IzJtXXmhTaRWux7f3YX3ozIsZ1/kgohJbyxKc07j2yn36MjdC"
			"2se05OKxBRkbd21Zf6UZXKPWk2si4gdd5+LN4xslK3lbZ2TKt3S2YLhPoPetpEDYGtOCWzjzJQXY3u9H"
			"i176JKWLcXGFNpO9i6W/2hQ9GW26X7Pw3RKlPXSKzSxUFOW+ZnTysKAtTiWQc5Qt7TpDlGR0et+jy/m5"
			"ryZHhdIU5OnS8V0XjcWty4bONzrtrxGNw9p24SZ5q3ShTjLUfD3bHLH3nydi4G1/0+56Trhjhap64Y3R"
			"ymNzpTG5zS1UZ+p+D5ObpufMbnPmNztwHaxjc6MS5y9wKcpPd2j/rywU8oGPi/rdD2LjpR7dgqTeoWqn"
			"a/U5fuZLLv8AU5S26ltUfq8swxPPgxQver8z1bjRafQxab3dLXb8/5h7nPzR/3wp2Sk9S6Unp9oH1PKN"
			"hjFtPR3uZ8/QcC/a2VxfULbNTz/JyN87n5l/whTum29pkmL04DDEPKMzCC7N6O9S2s069DKO9c26mj1/"
			"M5fXoa3odjFH98Kdw23acjdP7fLB+hGoxMXpNJYK8m5l71x3SMTNHf6Fev14W9Lpc2k994KeU/qdLw6F"
			"LtfubsDQU8MGLBcei3zJLOXFHK7mmxNY3auvgrwZ70Jsehq5rrv3gp6Z/hdGt7JzfJ0N2Aa+oeGMFsJc"
			"FmvyvMJLJlfaSCigUSqa5gKNHBY5ISDa8Gbm2Y/3wp6x5zqUVnV1PJ0N2CBo+KHmMICwSj1Gucp89KSj"
			"JRkoyUSjBNY0poSA2uDV49tbv4Ap942F6dnQ1dHteOHdIBo+KUZGEANFih6Z6ZRx0GQML5hgC37PPpYr"
			"srv4wp809p0a7cPFtV+Tx68EBANB8JgvPRk8wUDCED5Pb49XVuaFlbv5Qp9k4HOXay0cG0ze37EO7AEA"
			"NUPP4X8L4QSlK3uR7NK5dlat3/8Ke0bDz09Lco8Hv0a8GpfsQm7AoTAQSmK2bkdnTkpW1yxKd+sFPwGw"
			"89PU1WUcLINHUvYL9ghaZoglxWrlJssbyZHO/6BT9U0HOXPUqUINrBBBRUFFRSkJGl1+RanfKFP6hSc5"
			"5dS3UoAhpaSChTnfWCn3TG53mn2a3CLSkQj/YFbWIkpWhIlotAhiP6ArZSRK0pE3S0kIhDIfiCtdMkQt"
			"IkQgYgQl8EKSuKJFVH4QrShE+mIQxDEIfBDSdAJFzlf1ArRluJaUiEMYjvFpBDCucq+wFZ8UuJIIZCja"
			"FsZElHuBWUTpWtIIZV+uEPdCsoTEtKiJKdAEV9o8K1pSghYRLhSmqEGdAd9ovlVRPZUSVgnSl8tIhQJp"
			"aHR4TIuJLGLWmuha68TFEXVQDP2+koxeb0UjKvSCsCUvltELARXpUq/ZMUSYYaColpQIIVEXKZP39fqp"
			"fKVVPhPRRYlKwpLQY+ecxAtIshYRLIWTgtFdKSEUQsRZJEaAZfRfMWvVyNFwwylYWmMENPOQxMSIVz1V"
			"rqpnrpEVYqUKYQWsE15Q1VCe2uJpSQCCEKwvWPpISVxk86GMF0hlUStIkFrBlwXY96GfQsmNKVCawiMS"
			"meqoUnGIUW0sWmkEMSFFJMMSVshhXOi6SaXvMnyStBj5anCsQrS0FvmhOMWlKBLEMhUEUZFDPP0UJW+J"
			"TFCo58HRh4tWhQVyidbIG1YogrCIZ4zg0ECSqhKaVWJAyJdWlVRGYmQr0EJGAkiiUel8yujoe8L6VeGl"
			"PV8gmJoVgYhL52GMWMYgGQpYxAhMULEPmKqIhYtMLEoK6Wj0S0ofJ4ojs+bVWvQURVgRVnSoTEmvKDGg"
			"x8EKCFRSQQoBAIQ0NWUi7KA7KWNCsoeZVnSoeTSRVUCOETSRV74IUY0IjCs+YmVYlgkTShYQ8weiiZV9"
			"gKzTExES0iQnYQo1iRMSSqzuhWjMaKql6CRIsSgGIQ+W0pWJSQsR6gVrJkYxaVpEiRAtDQSoeRVQj4wr"
			"XBLBjUqJ0pEAhDFI/sCtpnEhAJSJEiBAhH0Qrd4xoR/IFb+I+zW5gmgIUJSK/OFbWJKCEAiyJSlv9AVs"
			"pJAgQIykSCFKVq+QK10esCEPjyRKbhIxiCJX4QrSj1gQhRIkWJVlLTaCEQonV3QrRi7CECGpFapaUooI"
			"ZDd9gKz4QPoWJWtXfJFCUUFe4FZRPAxCAStfzx5QK9gKyhLEIfJEVRJd2jwoYhCRbSwhaEXQToCT3mi5"
			"4gzqHqwWGk6UrEoh18vCZIGIStCIRqEJQtRFxJBfB1VG3oUkCYuqFYFIfJ0tBRDpXeyWmIWtVBiGhKoi"
			"nSzt5eJD5oRI6Bxi2FYoIjBb56yQgQIFtLCBbbAgIkIStQrKeFNUVr8RQURRV0DIlsKwyUFPn9SkpQxK"
			"0QjERIhSgFshWJCBAIuylKuUFarIVAl8tpIqpWECGmOgppsJQRKoIhStoiqLWpSJxChiATcFtyLhr2RS"
			"JArAiMxw3VC6CECXzwrYaQLYKBETEQNiGMTdJF6C4eihoLfLUIViJCHzIgoKCEWxCFKQpJKoGRkS2QpV"
			"QQ0GPi26EXRrqNichYlMETGBWFLYhR4UlVIIiUwhGJSMQti0vltKhCKqUCXzGxij6HNnMmgI6s64YZ+B"
			"CIUBWBbEoBESUIWlQJWhK1CUIWlb48sVEpEkSUAuMeZ0UJfJ2MNTViYiuoKyjHFCoWliYlRmNLXzGlr4"
			"8oJVFtSEygoGxhXaT0FaihWohrTJWBSiEQhKIUytBTQU+CpROkXeyJUKUY1KjCs+YmjBCAQhbRfMHrCE"
			"y+wFZpiamEEIShjEpbrEkDAWnuhWjIlRIYCFFpCWJEiXy2gQIELWr1ArSiVKS+i0CAQJjBCh5K0q+MK1"
			"0eUNoKRIkQCGjU4xXxBWuFtQobQECGi0iRX84VtwWoUK/kCt/EAA";
		return p_s_data;
	}

	static inline uint32_t *p_Decompress()
	{
		return p_Decode_RLE_Huff_Base64(p_s_Base64_Data(), 150, 57, 6397, 3, 3, 2, false);
	}

protected:
	static void UnPredict_ImagePlane(uint8_t *p_buffer, int n_width, int n_height, int n_pred_type)
	{
		int n_first_row = (n_pred_type == 1)? 0 : 1;
		int n_first_col = (n_pred_type == 0)? 0 : 1;
		p_buffer += n_first_row * n_width;
		for(int y = n_first_row; y < n_height; ++ y) {
			if(n_first_col)
				++ p_buffer;
			for(int x = n_first_col; x < n_width; ++ x, ++ p_buffer) {
				if(n_pred_type == 0)
					*p_buffer += p_buffer[-n_width];
				else if(n_pred_type == 1)
					*p_buffer += p_buffer[-1];
				else if(n_pred_type == 2) {
					*p_buffer += (int(p_buffer[-1]) + int(p_buffer[-n_width]) +
						int(p_buffer[-n_width - 1])) / 3;
				} else {
					int a = p_buffer[-1], b = p_buffer[-n_width], c = p_buffer[-n_width - 1];
					int p = a + b - c, pa = abs(p - a), pb = abs(p - b), pc = abs(p - c);
					*p_buffer += (pa <= pb && pa <= pc)? a : ((pb <= pc)? b : c);
				}
			}
		}
	}

	static uint32_t *p_Decode_RLE_Huff_Base64(const char *p_s_base64,
		int n_image_width, int n_image_height, int n_huff_stage_size,
		int n_predictor_y, int n_predictor_uv, int n_subsample, bool b_gray)
	{
		int n_base64_length = strlen(p_s_base64);
		int n_base64_out_size = (n_base64_length / 4) * 3 +
			max(int(n_base64_length % 4) - 1, 0);

		int n_image_size = n_image_width * n_image_height;
		int n_chroma_w = (n_image_width + n_subsample - 1) / n_subsample;
		int n_chroma_h = (n_image_height + n_subsample - 1)/ n_subsample;
		int n_chroma_plane_size = n_chroma_w * n_chroma_h;
		int n_chroma_size = n_chroma_plane_size * 2;
		int n_image_data_size = n_image_width * n_image_height + ((b_gray)? 0 : n_chroma_size);

		int n_prehuff_size = max(n_base64_out_size, n_image_data_size);
		int n_temp_buffer_size = n_prehuff_size + n_huff_stage_size;
		uint8_t *p_temp_buffer;
		if(!(p_temp_buffer = new(std::nothrow) uint8_t[n_temp_buffer_size]))
			return 0;;
		uint32_t *p_raster;
		if(!(p_raster = new(std::nothrow) uint32_t[n_image_width * n_image_height])) {
			delete[] p_temp_buffer;
			return 0;
		}

		{
			int p_ic_tab[256];
			for(int i = 0; i < 256; ++ i) {
				p_ic_tab[i] = (isupper(i))? i - 'A' : (islower(i))? i - 'a' + 26 :
					(isdigit(i))? i - '0' + 52 : (i == '+')? 62 : (i == '/')? 63 : -1;
			}
			const uint8_t *p_src = (const uint8_t*)p_s_base64;
			uint8_t *p_dst = p_temp_buffer;
			for(const uint8_t *p_end = p_src + n_base64_length - 3; p_src < p_end; p_src += 4) {
				uint8_t p_tmp[] = {p_ic_tab[p_src[1]], p_ic_tab[p_src[2]], };
				*p_dst ++ = (p_ic_tab[p_src[0]] << 2) | (p_tmp[0] >> 4);
				*p_dst ++ = (p_tmp[0] << 4) | (p_tmp[1] >> 2);
				*p_dst ++ = (p_tmp[1] << 6) | p_ic_tab[p_src[3]];
			}
			if(n_base64_length % 4 == 3) {
				uint8_t n_tmp = p_ic_tab[p_src[1]];
				*p_dst ++ = (p_ic_tab[p_src[0]] << 2) | (n_tmp >> 4);
				*p_dst ++ = n_tmp | (p_ic_tab[p_src[2]] >> 2);
			} else if(n_base64_length % 4 == 2) {
				*p_dst ++ = (p_ic_tab[p_src[0]] << 2) | (p_ic_tab[p_src[1]] >> 4);
			}
		}
		{
			const uint8_t *p_huff_src = p_temp_buffer, *p_huff_end = p_huff_src + n_base64_out_size;
			_ASSERTE(p_huff_src + 16 * sizeof(int) <= p_huff_end);
			const int *p_code_num = (const int*)p_huff_src; p_huff_src += 16 * sizeof(int);
			int p_min_code[16], p_max_code[16], p_table_off[16], n_code_num = 0;
			for(int i = 0, n_cw = 0; i < 16; ++ i, n_cw <<= 1) {
				p_min_code[i] = n_cw;
				p_max_code[i] = (n_cw += p_code_num[i]);
				p_table_off[i] = n_code_num - p_min_code[i];
				n_code_num += p_code_num[i];
			}
			_ASSERTE(p_huff_src + n_code_num <= p_huff_end);
			const uint8_t *p_symbol = p_huff_src; p_huff_src += n_code_num;
			uint8_t *p_huff_dest = p_temp_buffer + n_prehuff_size;
			for(int n_byte = 0, n_bit_num = 0, n_counter = n_huff_stage_size; n_counter --;) {
				for(int i = 0, n_code = 0;; ++ i) {
					_ASSERTE(i < 16);
					if(!(n_bit_num-- )) {
						_ASSERTE(p_huff_src < p_huff_end);
						n_byte = *p_huff_src ++;
						n_bit_num = 7;
					}
					n_code = (n_code << 1) | (n_byte >> 7);
					n_byte = (n_byte << 1) & 0xff;
					if(n_code >= p_min_code[i] && n_code < p_max_code[i]) {
						*p_huff_dest ++ = p_symbol[n_code + p_table_off[i]];
						break;
					}
				}
			}
		}
		{
			uint8_t *p_rle_dest = p_temp_buffer;
			const uint8_t *p_rle_src = p_temp_buffer + n_prehuff_size,
				*p_src_end = p_rle_src + n_huff_stage_size;
			for(; p_rle_src != p_src_end;) {
				uint8_t n_code = *p_rle_src ++;
				bool b_compressed = n_code & 1;
				int n_run_length = (n_code >> 1) + 1;
				_ASSERTE(p_rle_src + ((b_compressed)? 1 : n_run_length) <= p_src_end);
				while(n_run_length --)
					*p_rle_dest ++ = (b_compressed)? *p_rle_src : *p_rle_src ++;
				if(b_compressed)
					++ p_rle_src;
			}
		}

		if(!b_gray) {
			uint8_t *p_y = p_temp_buffer;
			uint8_t *p_u = p_y + n_image_size;
			uint8_t *p_v = p_u + n_chroma_plane_size;
			UnPredict_ImagePlane(p_y, n_image_width, n_image_height, n_predictor_y);
			UnPredict_ImagePlane(p_u, n_chroma_w, n_chroma_h, n_predictor_uv);
			UnPredict_ImagePlane(p_v, n_chroma_w, n_chroma_h, n_predictor_uv);
			for(int y = 0, h = n_image_height; y < h; ++ y) {
				for(int x = 0, w = n_image_width; x < w; ++ x) {
					int n_cr_idx = x / n_subsample + y / n_subsample * n_chroma_w;
					int Y = *p_y ++, u = p_u[n_cr_idx] - 128, v = p_v[n_cr_idx] - 128;
					uint8_t r = uint8_t(max(0, min(255, Y + 1.402f * v)));
					uint8_t g = uint8_t(max(0, min(255, Y - 0.34414f * u - 0.71414f * v)));
					uint8_t b = uint8_t(max(0, min(255, Y + 1.772f * u)));
					p_raster[x + y * w] = 0xff000000 | (r << 16) | (g << 8) | b;
				}
			}
		} else {
			UnPredict_ImagePlane(p_temp_buffer, n_image_width, n_image_height, n_predictor_y);
			uint32_t *p_dest = p_raster;
			for(const uint8_t *p_y = p_temp_buffer, *p_end = p_y +
			   n_image_height * n_image_width; p_y != p_end; ++ p_y)
				*p_dest ++ = 0xff000000 | (*p_y << 16) | (*p_y << 8) | *p_y;
		}

		delete[] p_temp_buffer;
		
		return p_raster;
	}
};

#endif //__OPENGL_LOGO_2_0_TGA_INCLUDED
